[prism] regression in retry precedence
Status: Closed   

Priority: Normal   

Assignee: kddnewton (Kevin Newton)   

Target version:    

ruby -v: ruby 3.4.0dev (2024-09-15T01:06:11Z

master 532af89e3b) +PRISM

[arm64-darwin23]

Backport: 3.1: DONTNEED, 3.2: DONTNEED, 3.3:

DONTNEED

Description

Since prism has been made the default, our test suite now fail to boot with the following error:

syntax error found (SyntaxError)

  298 |           raise e

  299 |         else

> 300 |           retry

      |           ^~~~~ Invalid retry after else

  301 |         end

  302 |       end

 Here's the code in question, that reproduce the error:

def retry_thing(times: 1)

  retries ||= 0

  begin

    yield

  rescue RuntimeError => e

    raise if (retries += 1) > times

    begin

      refresh!

    rescue

      raise e

    else

      retry

    end

  end

end

Associated revisions

Revision 7e2ae30f8b30f9f9f7250abffc1c311115548bba - 09/16/2024 07:55 PM - kddnewton (Kevin Newton)

[ruby/prism] Handle retry doubly nested under rescue

Fixes [Bug #20747]

https://github.com/ruby/prism/commit/d3194715a9

Revision 7e2ae30f8b30f9f9f7250abffc1c311115548bba - 09/16/2024 07:55 PM - kddnewton (Kevin Newton)

[ruby/prism] Handle retry doubly nested under rescue

Fixes [Bug #20747]

https://github.com/ruby/prism/commit/d3194715a9

Revision 7e2ae30f - 09/16/2024 07:55 PM - kddnewton (Kevin Newton)

[ruby/prism] Handle retry doubly nested under rescue

Fixes [Bug #20747]
https://github.com/ruby/prism/commit/d3194715a9
https://github.com/ruby/prism/commit/d3194715a9


https://github.com/ruby/prism/commit/d3194715a9

History

#1 - 09/16/2024 08:34 AM - byroot (Jean Boussier)

- Backport changed from 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN to 3.1: DONTNEED, 3.2: DONTNEED, 3.3: DONTNEED

#2 - 09/16/2024 07:28 PM - kddnewton (Kevin Newton)

I have opened a PR to fix this: https://github.com/ruby/prism/pull/3073.

#3 - 09/16/2024 07:55 PM - kddnewton (Kevin Newton)

- Status changed from Open to Closed
